workRPMGui = {}

local workRPMGui_mt = Class(workRPMGui, ScreenElement)

function workRPMGui:new(target, custom_mt)
    local self = ScreenElement:new(target, workRPMGui_mt)
    self.returnScreenName = ""
    return self
end

function workRPMGui:onOpen()
    workRPMGui:superClass().onOpen(self)
	FocusManager:setFocus(self.backButton)
	if self.target ~= nil then
		self.workRPMGuiHeader.text = g_i18n:getText('GUI_WRPM_SETTINGS') .. ' (' .. self.target:wrpmGetFullName() .. ')'
	end
end

function workRPMGui:onClose()
    workRPMGui:superClass().onClose(self)
end

function workRPMGui:onClickBack()
    workRPMGui:superClass().onClickBack(self)
	--WorkRPM:guiClosed()
end

function workRPMGui:onClickOk()
    workRPMGui:superClass().onClickOk(self)
	WorkRPM:settingsFromGui(self.target, self.tipping:getState(), self.folding:getState(), self.rotating:getState(), self.lifting:getState(), self.movingTools:getState(), self.pipe:getState(), self.currentConfig:getState(), 
										self.tippingCurrent:getState(), self.foldingCurrent:getState(), self.rotatingCurrent:getState(), self.liftingCurrent:getState(), self.movingToolsCurrent:getState(), self.pipeCurrent:getState(),
										self.showhelp:getState(), self.showHud:getState(), self.hudSize:getState(), self.hudSizeCustom:getState() )
    self:onClickBack()
end
function workRPMGui:setTarget(target)
	self.target = target
end
function workRPMGui:onIngameMenuHelpTextChanged(element)
end

function workRPMGui:onCreateWrpmGuiHeader(element)
	self.workRPMGuiHeader = element
	element.text = g_i18n:getText('GUI_WRPM_SETTINGS')
end
function workRPMGui:onCreateWrpmGuiHeaderGlobal(element)
	element.text = g_i18n:getText('GUI_WRPM_GLOBAL')
end
function workRPMGui:onCreateWrpmGuiHeaderCurrent(element)
	element.text = g_i18n:getText('GUI_WRPM_CURRENT')
end
function workRPMGui:onCreateWrpmGuiHeaderMisc(element)
	element.text = g_i18n:getText('GUI_WRPM_MISC')
end
function workRPMGui:onCreateTipping(element)
    self.tipping = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_TIPPING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_TIPPING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setTipping(index)
    self.tipping:setState(index, false)
end
function workRPMGui:onCreateFolding(element)
    self.folding = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_FOLDING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_FOLDING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setFolding(index)
    self.folding:setState(index, false)
end
function workRPMGui:onCreateRotating(element)
    self.rotating = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_ROTATING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_ROTATING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setRotating(index)
    self.rotating:setState(index, false)
end
function workRPMGui:onCreateLifting(element)
    self.lifting = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_LIFTING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_LIFTING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setLifting(index)
    self.lifting:setState(index, false)
end
function workRPMGui:onCreateMovingTools(element)
    self.movingTools = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_MOVINGTOOLS')
	element.toolTipText = g_i18n:getText('GUI_WRPM_MOVINGTOOLS_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setMovingTools(index)
    self.movingTools:setState(index, false)
end
function workRPMGui:onCreatePipe(element)
    self.pipe = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_PIPE')
	element.toolTipText = g_i18n:getText('GUI_WRPM_PIPE_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setPipe(index)
    self.pipe:setState(index, false)
end

function workRPMGui:onCreateCurrentConfig(element)
    self.currentConfig = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_CURRENT_CONFIG')
	element.toolTipText = g_i18n:getText('GUI_WRPM_CURRENT_CONFIG_TOOLTIP')
    local currentConfigs = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       currentConfigs[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(currentConfigs)
	
end
function workRPMGui:setCurrentConfig(index)
    self.currentConfig:setState(index, false)
end
function workRPMGui:onCreateTippingCurrent(element)
    self.tippingCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_TIPPING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_TIPPING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setTippingCurrent(index)
    self.tippingCurrent:setState(index, false)
end
function workRPMGui:onCreateFoldingCurrent(element)
    self.foldingCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_FOLDING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_FOLDING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setFoldingCurrent(index)
    self.foldingCurrent:setState(index, false)
end
function workRPMGui:onCreateRotatingCurrent(element)
    self.rotatingCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_ROTATING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_ROTATING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setRotatingCurrent(index)
    self.rotatingCurrent:setState(index, false)
end
function workRPMGui:onCreateLiftingCurrent(element)
    self.liftingCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_LIFTING')
	element.toolTipText = g_i18n:getText('GUI_WRPM_LIFTING_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setLiftingCurrent(index)
    self.liftingCurrent:setState(index, false)
end
function workRPMGui:onCreateMovingToolsCurrent(element)
    self.movingToolsCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_MOVINGTOOLS')
	element.toolTipText = g_i18n:getText('GUI_WRPM_MOVINGTOOLS_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setMovingToolsCurrent(index)
    self.movingToolsCurrent:setState(index, false)
end
function workRPMGui:onCreatePipeCurrent(element)
    self.pipeCurrent = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_PIPE')
	element.toolTipText = g_i18n:getText('GUI_WRPM_PIPE_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setPipeCurrent(index)
    self.pipeCurrent:setState(index, false)
end
function workRPMGui:onCreateShowhelp(element)
    self.showhelp = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_SHOWHELP')
	element.toolTipText = g_i18n:getText('GUI_WRPM_SHOWHELP_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setShowhelp(index)
    self.showhelp:setState(index, false)
end
function workRPMGui:onCreateShowHud(element)
    self.showHud = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_SHOW_HUD')
	element.toolTipText = g_i18n:getText('GUI_WRPM_SHOW_HUD_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.booleansTexts, 1 do
       values[i] = WorkRPM.booleansTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setShowHud(index)
    self.showHud:setState(index, false)
end
function workRPMGui:onCreateHudSize(element)
    self.hudSize = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_HUD_SIZE')
	element.toolTipText = g_i18n:getText('GUI_WRPM_HUD_SIZE_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.hudSizesTexts, 1 do
       values[i] = WorkRPM.hudSizesTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setHudSize(index)
    self.hudSize:setState(index, false)
end
function workRPMGui:onCreateHudSizeCustom(element)
    self.hudSizeCustom = element
	element.labelElement.text = g_i18n:getText('GUI_WRPM_HUD_SIZE_CUSTOM')
	--element.toolTipText = g_i18n:getText('GUI_WRPM_HUD_SIZE_TOOLTIP')
    local values = {}

	for i = 1, #WorkRPM.hudSizesCustomTexts, 1 do
       values[i] = WorkRPM.hudSizesCustomTexts[i]
    end
	
    element:setTexts(values)
end
function workRPMGui:setHudSizeCustom(index)
    self.hudSizeCustom:setState(index, false)
end
function workRPMGui:onClickCurrentConfig(element)
	self.tippingCurrent:setDisabled(not WorkRPM.booleans[self.currentConfig:getState()])
	self.foldingCurrent:setDisabled(not WorkRPM.booleans[self.currentConfig:getState()])
	self.rotatingCurrent:setDisabled(not WorkRPM.booleans[self.currentConfig:getState()])
	self.liftingCurrent:setDisabled(not WorkRPM.booleans[self.currentConfig:getState()])
	self.movingToolsCurrent:setDisabled(not WorkRPM.booleans[self.currentConfig:getState()])
	self.pipeCurrent:setDisabled(not WorkRPM.booleans[self.currentConfig:getState()])
end
function workRPMGui:onClickHudSize(element)
	local dis = self.hudSize:getState() == 5
	self.hudSizeCustom:setDisabled(not dis)
end

function workRPMGui:onClickResetButton()
    WorkRPM:settingsResetGui()
end