--
-- Work RPM for FS19
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0.0.0 - 2020-11-11 - first release
--
source(Utils.getFilename("gui/wrpmGui.lua", g_currentModDirectory))
source(Utils.getFilename("workRPM.lua", g_currentModDirectory))

WorkRPM_register = {}

function WorkRPM_register:loadMap()
end
function WorkRPM_register:register(name)
	if g_specializationManager:getSpecializationByName("WorkRPM") == nil then
		if WorkRPM == nil then 
			print("ERROR: unable to add specialization 'WorkRPM'")
		else 
			for i, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and i ~= "locomotive" then 
					local isDrivable  = false
					local isEnterable = false
					local hasMotor    = false 
					local isAttachable    = false 
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "drivable"  then 
							isDrivable = true 
						elseif name == "motorized" then 
							hasMotor = true 
						elseif name == "enterable" then 
							isEnterable = true
						elseif name == "attachable" then 
							isAttachable = true 
						end 
					end 
					if isDrivable and isEnterable and hasMotor then
					  typeDef.specializationsByName["WorkRPM"] = WorkRPM
					  table.insert(typeDef.specializationNames, "WorkRPM")
					  table.insert(typeDef.specializations, WorkRPM)  
					end 
				end 
			end   
		end 
	end
end
VehicleTypeManager.finalizeVehicleTypes = Utils.prependedFunction(VehicleTypeManager.finalizeVehicleTypes, WorkRPM_register.register)
print("----WorkRPM registered.")

addModEventListener(WorkRPM_register);